OUTPUT_FORMAT("elf32-littlearm", "elf32-bigarm", "elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(reset_vector)
/*GROUP(libgcc.a)*/
MEMORY
{
	sram : ORIGIN = 0, LENGTH = 8K
	ram : ORIGIN = 0x02000000, LENGTH = 512K
}

SECTIONS
{
_sram_start = 0x0;
_ram_start = 0x2000000;

.text 0x2010000 : 
{
	_stext = ABSOLUTE(.);
	startup*(.text*) 
    	*(.text)
	*(.text*) 
	*(.gnu.warning) 
	*(.gnu.linkonce.t.*) 
	*(.glue_7) *(.glue_7t)
	*(.stub)
} > ram 
_etext = .; PROVIDE (__etext = .);

.data ALIGN (0x4) : 
{ 
	_sdata = ABSOLUTE (.); 
	*(.data*) 
	*(.data1) 
	*(.rodata.*)
	*(.rodata*)
	*(.gnu.linkonce.d.*) 
	. = ALIGN (4); 
	*(.dynamic) 
	. = ALIGN (4); 
	*(.2ram.*)
} > ram 

.sdata ALIGN (0x4) : 
{
	*(.sdata) 
	*(.sdata.*)
	*(.gnu.linkonce.s.*)
} > ram

_edata = .;

.bss ALIGN (0x4) : 
{ 
	__bss_start__ = ABSOLUTE (.); 
	*(.scommon) 
	*(.dynsbss) 
    	*(.sbss)
	*(.sbss*) 
	*(.gnu.linkonce.sb.*) 
	*(.dynbss) 
   	*(.bss)
	*(.bss*) 
	*(.gnu.linkonce.b.*) 
	*(COMMON)
	__bss_end__ = ABSOLUTE (.); 
} > ram

. = ALIGN(20);
_end = .; PROVIDE (end = .);

.vectors 0x0 : AT ( _end )
{ 
	_v_start = ABSOLUTE (.);
	*(.vectors) 
	_v_end = ABSOLUTE (.);
} > sram

_main_stack = _ram_start + 512K;
_stack_end = _main_stack - 10K;
_fiq_stack = _sram_start + 8K;
_int_stack = _fiq_stack - 40;

  /* Stabs debugging sections.  */
  .stab 0 : { *(.stab) }
  .stabstr 0 : { *(.stabstr) }
  .stab.excl 0 : { *(.stab.excl) }
  .stab.exclstr 0 : { *(.stab.exclstr) }
  .stab.index 0 : { *(.stab.index) }
  .stab.indexstr 0 : { *(.stab.indexstr) }
  .comment 0 : { *(.comment) }
  /* DWARF debug sections.
     Symbols in the DWARF debugging sections are relative to the beginning
     of the section so we begin them at 0.  */
  /* DWARF 1 */
  .debug          0 : { *(.debug) }
  .line           0 : { *(.line) }
  /* GNU DWARF 1 extensions */
  .debug_srcinfo  0 : { *(.debug_srcinfo) }
  .debug_sfnames  0 : { *(.debug_sfnames) }
  /* DWARF 1.1 and DWARF 2 */
  .debug_aranges  0 : { *(.debug_aranges) }
  .debug_pubnames 0 : { *(.debug_pubnames) }
  /* DWARF 2 */
  .debug_info     0 : { *(.debug_info) }
  .debug_abbrev   0 : { *(.debug_abbrev) }
  .debug_line     0 : { *(.debug_line) }
  .debug_frame    0 : { *(.debug_frame) }
  .debug_str      0 : { *(.debug_str) }
  .debug_loc      0 : { *(.debug_loc) }
  .debug_macinfo  0 : { *(.debug_macinfo) }
  /* SGI/MIPS DWARF 2 extensions */
  .debug_weaknames 0 : { *(.debug_weaknames) }
  .debug_funcnames 0 : { *(.debug_funcnames) }
  .debug_typenames 0 : { *(.debug_typenames) }
  .debug_varnames  0 : { *(.debug_varnames) }
}

