/**************************************************************************************************
 * (C) Copyright 2004, ELSTA Sp. z o.o., Wieliczka, Poland,  http://www.elsta.pl
 *
 * Author: Artur Lipowski
 * Product Manager: Cezary Worek
 *
 * No guarantees, warrantees, or promises, implied or otherwise.
 * May be used for hobby or commercial purposes provided copyright
 * notice remains intact. 
 * 
 * $RCSfile: os_cpu.h,v $
 * $Revision: 1.8 $
 * $Date: 2004/04/25 07:17:01 $
 *
 *************************************************************************************************/

#ifndef _OS_CPU_H_
#define _OS_CPU_H_

#include <inttypes.h>
#include <arm.h>


#define INT_CONTEXT_SWITCH SOFTINT_NOARG(0)

static inline unsigned disable_ints(void)
{
	unsigned old;
	SOFTINT_GET(1, old);
	return old;
}

static inline unsigned enable_ints(void)
{
	unsigned old;
	SOFTINT_GET(2, old);
	return old;
}

static inline void restore_ints(unsigned old)
{
	SOFTINT_SET(3, old);
}


/*typedef uint32_t	BOOLEAN;*/
typedef uint8_t		INT8U;                    /* Unsigned  8 bit quantity */
typedef int8_t		INT8S;                    /* Signed    8 bit quantity */
typedef uint32_t	INT16U;                   /* Unsigned 16 bit quantity */
typedef int32_t		INT16S;                   /* Signed   16 bit quantity */
typedef uint32_t	INT32U;                   /* Unsigned 32 bit quantity */
typedef int32_t		INT32S;                   /* Signed   32 bit quantity */
typedef uint32_t	OS_STK;                   /* Stack is 32 bit quantity */
typedef uint32_t	OS_CPU_SR;
typedef INT32U		OS_FLAGS;   /* Date type for event flag bits (8, 16 or 32 bits) */

#define OS_STK_GROWTH 1

#define OS_CRITICAL_METHOD 3
#define OS_ENTER_CRITICAL() do { cpu_sr = disable_ints(); } while(0);
#define OS_EXIT_CRITICAL() do { restore_ints(cpu_sr); } while(0);

#define OS_TASK_SW() INT_CONTEXT_SWITCH


#endif	/* _OS_CPU_H_ */
