/**************************************************************************************************
 * (C) Copyright 2004, ELSTA Sp. z o.o., Wieliczka, Poland,  http://www.elsta.pl
 *
 * Author: Artur Lipowski
 * Product Manager: Cezary Worek
 *
 * No guarantees, warrantees, or promises, implied or otherwise.
 * May be used for hobby or commercial purposes provided copyright
 * notice remains intact. 
 * 
 * $RCSfile: os_cpu_c.c,v $
 * $Revision: 1.8 $
 * $Date: 2004/04/22 19:53:18 $
 *
 *************************************************************************************************/

#include <arm.h>
#include <stdio.h>
#include "includes.h"


#ifndef OS_IN_ARM_MODE
#define DEFAULT_PSR (CPSR_SYSTEM_MODE|CPSR_THUMB_ENABLE)
#else
#define DEFAULT_PSR (CPSR_SYSTEM_MODE)
#endif	// OS_IN_ARM_MODE

//static char sbuf[120];

OS_STK *OSTaskStkInit(void (*task)(void*), void *pdata, OS_STK *ptos, INT16U opt)
{
	// build a context for the new task
	*ptos = 0;			// lr_sys
	*--ptos = 0;			// sp_sys
	*--ptos = 0xcccc;		// r12
	*--ptos = 0xbbbb;		// r11
	*--ptos = 0xaaaa;		// r10
	*--ptos = 0x9999;		// r9
	*--ptos = 0x8888;		// r8
	*--ptos = 0x7777;		// r7
	*--ptos = 0x6666;		// r6
	*--ptos = 0x5555;		// r5
	*--ptos = 0x4444;		// r4
	*--ptos = 0x3333;		// r3
	*--ptos = 0x2222;		// r2
	*--ptos = 0x1111;		// r1
	*--ptos = (unsigned) pdata;	// r0
#ifndef OS_IN_ARM_MODE
	// NOTE:  or'ed with 1 below since tasks start in thumb mode
	*--ptos = (OS_STK) task | 1;	// task restart address
#else
	*--ptos = (OS_STK) task;	// task restart address
#endif	// OS_IN_ARM_MODE
	*--ptos = DEFAULT_PSR;		// task cpsr

	ptos[15]  = (unsigned)ptos;	// set initial SP value
/*
	sprintf(sbuf, "OSTaskStkInit:  task: %p, pdata: %p, ptos: %p\n\r", 
			task, pdata, ptos);
	dbgstr(sbuf);
*/
	return ptos;
}

